import requests
import time
import logging
ipflag=0
ipnum=1
slbnum=1
yidongnum=0
dianxinnum=0
import json
def getlogger():
    # 第一步，创建一个logger
    logger = logging.getLogger()
    logger.setLevel(logging.INFO)  # Log等级总开关
    # 第二步，创建一个handler，用于写入日志文件
    ch = logging.StreamHandler()
    ch.setLevel(logging.DEBUG)  # 输出到console的log等级的开关
    # 第三步，定义handler的输出格式
    formatter = logging.Formatter("%(asctime)s - %(filename)s[line:%(lineno)d] - %(levelname)s: %(message)s")
    ch.setFormatter(formatter)
    # 第四步，将logger添加到handler里面
    logger.addHandler(ch)
def dns_record_create(domain,token,line,ip,name):
    api = "https://dnsapi.cn/Record.Create"
    data = {
        "login_token": token,
        "domain": domain,
        "record_type": "A",
        "sub_domain":name,
        "record_line": line,
        "value": ip,
        "ttl": 120,
        "format": "json"
    }
    headers = {
        "UserAgent": "python DDNS Client/4.6 (lanfox2018@163.com)"
    }
    req = requests.post(api, data=data,headers=headers)
    out_json=req.json()
    code = out_json["status"]["code"]
    if code=="1":
        logging.info("完成线路：{}，ip：{}的添加".format(line,ip))
    else:
        logging.info("在添加线路：{}，ip:{}出现错误，信息为：{}".format(line,ip,out_json["status"]["message"]))
        return False
def get_record_list(domain,token):
    api = "https://dnsapi.cn/Record.List"
    data = {
        "login_token": token,
        "domain": domain,
        "format": "json"
    }
    headers = {
        "UserAgent": "python DDNS Client/4.6 (lanfox2018@163.com)"
    }
    req = requests.post(api, data=data,headers=headers)
    out_json = req.json()
    code = out_json["status"]["code"]
    if code == "1":
        infos = {}
        records = out_json["records"]
        for record in records:
            if record["type"] == "A":
                if infos.__contains__(record["name"]) and record["line"] in ["电信", "联通", "移动"]:
                    linedict = infos[record["name"]]
                    if linedict.__contains__(record["line"]):
                        iplist = linedict[record["line"]]
                        iplist.append(record["value"])
                        linedict[record["line"]] = iplist
                    else:
                        iplist = []
                        iplist.append(record["value"])
                        linedict[record["line"]] = iplist
                elif record["line"] in ["电信", "联通", "移动"]:
                    linedict = {}
                    iplist = []
                    iplist.append(record["value"])
                    linedict[record["line"]] = iplist
                    infos[record["name"]] = linedict
        return infos
    else:
        logging.info("通过api查询域名：{}异常，结束，退出==={}".format(domain, req.text))
        exit()
def setdnspod(domain,token):
    global slbnum
    global ipnum
    infos=get_record_list(domain,token)
    linelist = ["电信", "联通", "移动"]
    if infos=={}:
        logging.info("未发现电信、联通、移动的线路A记录，将要进行半自动配置".format())
        time.sleep(1.5)
        while True:
            name = input("请输入主机记录名称，如@或者www等：")
            time.sleep(1.5)
            ipinfo = input("请依次输入电信、联通和移动的ip，中间用|隔开：")
            ipinfolist=ipinfo.split("|")
            if len(ipinfolist)!=3:
                logging.info("ip地址格式不对或者数量不对，请检查是否输入错误，请重新运行脚本！！！")
                time.sleep(1.5)
                exit()
            else:
                n=0
                flag=True
                for each in ipinfolist:
                    flag=dns_record_create(domain,token,linelist[n],each,name)
                    n=n+1
                if flag==False:
                    logging.info("在添加线路ip时候错误，请检查后再重新运行脚本")
                    exit()
            if input("还需要添加其他主机记录吗？请输入1代表是，输入其它内容代表否：")=="1":
                time.sleep(1.5)
                continue
            else:
                break
    else:
       for k,v in infos.items():
           if len(v)!=3:
               logging.info("未发现包含电信、联通、移动的线路解析，请检查后重新运行本脚本，或者清空dnspod A记录重新运行脚本添加")
               exit()
    infos = get_record_list(domain, token)
    if input("是否开启A记录的负载均衡？请输入1代表是，输入其它内容代表否：") == "1":
        time.sleep(1.5)
        try:
            slbnum=int(input("请输入开启负载均衡的数量(数字2-10，建议10)："))
            time.sleep(1.5)
        except:
            logging.info("是否输入了非数字的字符，请重新运行本脚本继续")
            exit()
        logging.info("你输入的负载数是{},下面将进行ip解析配置".format(str(slbnum)))
        time.sleep(1.5)
        for k,v in infos.items():
            for line,ips in v.items():
                iplen=len(ips)
                if iplen==slbnum:
                    continue
                time.sleep(1.5)
                ipinfo=input("已发现A记录：{}，{}线路的{}个ip，请在输入{}个ip，中间用|隔开：".format(k,line,str(iplen),str(slbnum-iplen)))
                time.sleep(1.5)
                ipinfolist = ipinfo.split("|")
                if len(ipinfolist) != slbnum-iplen:
                    logging.info("ip地址格式不对或者数量不对，请检查是否输入错误，请重新运行脚本！！！")
                    time.sleep(1.5)
                    exit()
                else:
                    n = 0
                    flag = True
                    for each in ipinfolist:
                        flag = dns_record_create(domain, token, line, each, k)
                        n = n + 1
                    if flag == False:
                        logging.info("在添加线路ip时候错误，请检查后再重新运行脚本")
                        exit()
        ipnum=len(infos)*slbnum
    else:
        for k,v in infos.items():
            for line,ips in v.items():
                if len(ips)>1:
                    logging.info("发现记录下面有多个ip，如果不启用负载会出错，请启用负载或者删除多余记录")
                    exit()
def get_ip_list(path):
    iplist=[]
    with open(path, "r") as f:
        for line in f.readlines():
            iplist.append(tuple(eval(line.strip())))
    logging.info("在文件：{}中共获取到{}个备用ip".format(path,str(len(iplist))))
    return iplist
def get_dianxin_ip(iplist):
    ip=[]
    global dianxinnum
    for each in range(0,ipnum):
        ip.append(iplist[dianxinnum][0])
        dianxinnum=dianxinnum+1
        if dianxinnum>=len(iplist):
            dianxinnum=0
    return ip
def get_yidong_ip(iplist):
    ip=[]
    global yidongnum
    for each in range(0,ipnum):
        ip.append(iplist[yidongnum][0])
        yidongnum=yidongnum+1
        if yidongnum>=len(iplist):
            yidongnum=0
    return ip
def if_ip_qiang(ip):
    api = "http://{}/cdn-cgi/trace".format(ip)
    try:
        req = requests.get(api, timeout=3)
        if ip in req.text:
            logging.info("此ip：{}访问正常".format(ip))
        flag=True
    except:
        #重试一次
        try:
            logging.info("此ip：{}访问异常，重试一次".format(ip))
            req = requests.get(api, timeout=3)
            logging.info("此ip：{}访问正常".format(ip))
            flag = True
        except:
           logging.info("此ip：{}访问异常，请手动检查".format(ip))
           flag = False
    return flag
def execute(domain,token,dianxiniplist,yidongiplist):
    api="https://dnsapi.cn/Record.List"
    data = {
        "login_token": token,
        "domain": domain,
        "format": "json"
    }
    headers = {
        "UserAgent": "python DDNS Client/4.6 (lanfox2018@163.com)"
    }
    req=requests.post(api,data=data,headers=headers)
    out_json=req.json()
    code=out_json["status"]["code"]
    if code=="1":
        records=out_json["records"]
        logging.info("获取正常的ip，请稍后！！！")
        time.sleep(1.5)
        #获取未被墙的ip用于修改a记录
        dianxinip=get_dianxin_ip(dianxiniplist)
        liantongip=get_dianxin_ip(dianxiniplist)
        yidongip=get_yidong_ip(yidongiplist)
        #写入文件
        with open("cache", "w") as f:
            data={
                "ipnum":ipnum,
                "dianxinnum":dianxinnum,
                "yidongnum":yidongnum
            }
            f.write(json.dumps(data))
            f.flush()
        logging.info("获取到的正常电信IP：{}，联通IP：{}，移动IP：{}，进行替换".format(str(dianxinip),str(liantongip),str(yidongip)))
        time.sleep(1.5)
        api = "https://dnsapi.cn/Record.Modify"
        dianxinipnum=0
        liantongipnum=0
        yidongipnum=0
        for record in records:
            if record["type"]=="A":
                if record["line"]=="移动":
                    ip=yidongip[yidongipnum]
                    yidongipnum=yidongipnum+1
                elif record["line"] == "联通":
                    ip=liantongip[liantongipnum]
                    liantongipnum=liantongipnum+1
                elif record["line"]=="电信":
                    ip = dianxinip[dianxinipnum]
                    dianxinipnum = dianxinipnum + 1
                else:
                    continue
                data = {
                    "login_token": token,
                    "domain": domain,
                    "record_id": record["id"],
                    "sub_domain":record["name"],
                    "record_type": "A",
                    "record_line": record["line"],
                    "value": ip,
                    "ttl":120,
                    "format": "json"
                }
                headers = {
                    "UserAgent": "python DDNS Client/4.6 (lanfox2018@163.com)"
                }
                while True:
                    try:
                        req = requests.post(api, data=data,headers=headers,timeout=10)
                        break
                    except:
                        logging.info("请求超时异常，过10s重新请求")
                        time.sleep(10)
                out_json = req.json()
                code = out_json["status"]["code"]
                if code == "1":
                    logging.info("完成域名：{}下A记录:{},线路：{}的IP：{}的替换".format(domain,record["name"],record["line"],ip))
                else:
                    logging.info("通过api修改域名记录：{}异常，请手动检查==={}".format(domain,str(req.json())))
                time.sleep(0.5)
    else:
        logging.info("通过api查询域名：{}异常，请手动检查==={}".format(domain,req.text))
if __name__ == '__main__':
    getlogger()
    domain="xxx.com"
    token="id,Token"
    with open("cache","r") as f:
        j=json.loads(f.read())
        dianxinnum=j["dianxinnum"]
        yidongnum=j["yidongnum"]
        ipnum=j["ipnum"]
    if dianxinnum!=0 and yidongnum!=0:
        lastflag=input("是否继续上次执行，输入1代表是，其它代表否：")
    else:
        lastflag=0
    time.sleep(1.5)
    if lastflag!="1":
        #配置dnspod
        setdnspod(domain,token)
        yidongnum = 0
        dianxinnum = 0
    #执行主程序
    dianxiniplist = get_ip_list("电信.txt")
    yidongiplist= get_ip_list("移动.txt")
    if len(dianxiniplist)==0 or len(yidongiplist)==0:
        logging.info("电信或移动文件里面未发现ip地址，脚本执行结束")
        exit()
    n=1

    while True:
        execute(domain,token,dianxiniplist,yidongiplist)
        logging.info("当前执行完第{}次".format(str(n)))
        time.sleep(60*2)
        n=n+1